<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryRef"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="借阅人" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入借阅人姓名"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="审核状态" prop="auditState">
        <el-input
          v-model="queryParams.auditState"
          placeholder="请输入审核状态"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="RefreshRight" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['archive:borrow:remove']"
          >删除</el-button
        >
      </el-col>

      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="borrowList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="" align="center" prop="borrowingId" />
      <el-table-column label="档案id" align="center" prop="archiveId" />
      <el-table-column label="借阅人姓名" align="center" prop="userName" />
      <el-table-column label="借阅天数" align="center" prop="borrowDay" />
      <el-table-column label="审核状态" align="center" prop="auditState">
        <template #default="scope">
          <dict-tag
            :options="borrow_audit_state"
            :value="scope.row.auditState"
          />
        </template>
      </el-table-column>
      <el-table-column label="" align="center" prop="remark" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template #default="scope">
          <el-button
            link
            type="primary"
            icon="Edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['archive:borrow:edit']"
            >查看</el-button
          >
          <el-button
            link
            type="primary"
            icon="Delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['archive:borrow:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改借阅管理对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="borrowRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="借阅人" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入借阅人" />
        </el-form-item>
        <el-form-item label="借阅人姓名" prop="userName">
          <el-input v-model="form.userName" placeholder="请输入借阅人姓名" />
        </el-form-item>
        <el-form-item label="借阅天数" prop="borrowDay">
          <el-input v-model="form.borrowDay" placeholder="请输入借阅天数" />
        </el-form-item>
        <el-form-item label="借阅档案流程work_id" prop="borrowWorkId">
          <el-input
            v-model="form.borrowWorkId"
            placeholder="请输入借阅档案流程work_id"
          />
        </el-form-item>
        <el-form-item label="自身流程id" prop="workId">
          <el-input v-model="form.workId" placeholder="请输入自身流程id" />
        </el-form-item>
        <el-form-item label="档案id" prop="archiveId">
          <el-input v-model="form.archiveId" placeholder="请输入档案id" />
        </el-form-item>
        <el-form-item label="审核状态" prop="auditState">
          <el-input v-model="form.auditState" placeholder="请输入审核状态" />
        </el-form-item>
        <el-form-item label="" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Borrow">
import {
  listBorrow,
  getBorrow,
  delBorrow,
  addBorrow,
  updateBorrow,
} from "@/api/archive/borrow";

const { proxy } = getCurrentInstance();

const borrowList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    userId: null,
    userName: null,
    borrowDay: null,
    borrowWorkId: null,
    workId: null,
    archiveId: null,
    auditState: null,
  },
  rules: {},
});

const { queryParams, form, rules } = toRefs(data);

/** 查询借阅管理列表 */
function getList() {
  loading.value = true;
  listBorrow(queryParams.value).then((response) => {
    borrowList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    borrowingId: null,
    userId: null,
    userName: null,
    borrowDay: null,
    borrowWorkId: null,
    workId: null,
    archiveId: null,
    auditState: null,
    createBy: null,
    createTime: null,
    remark: null,
  };
  proxy.resetForm("borrowRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.borrowingId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加借阅管理";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _borrowingId = row.borrowingId || ids.value;
  getBorrow(_borrowingId).then((response) => {
    form.value = response.data;
    open.value = true;
    title.value = "修改借阅管理";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["borrowRef"].validate((valid) => {
    if (valid) {
      if (form.value.borrowingId != null) {
        updateBorrow(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBorrow(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _borrowingIds = row.borrowingId || ids.value;
  proxy.$modal
    .confirm('是否确认删除借阅管理编号为"' + _borrowingIds + '"的数据项？')
    .then(function () {
      return delBorrow(_borrowingIds);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    "archive/borrow/export",
    {
      ...queryParams.value,
    },
    `borrow_${new Date().getTime()}.xlsx`
  );
}

getList();
</script>
